<script>
  // Dimensions
  const width = 600;
  const height = 300;
  const margin = { top: 10, right: 10, bottom: 30, left: 60 };
  const innerWidth = width - margin.left - margin.right;
  const innerHeight = height - margin.top - margin.bottom;

  // Array
  const data = [
    { service: "Netflix", viewers: 2.9 },
    { service: "Amazon Prime Video", viewers: 1.3 },
    { service: "Disney+", viewers: 2.1 },
    { service: "Hulu", viewers: 0.9 },
    { service: "Apple TV", viewers: 1.1 },
    { service: "Rakuten", viewers: 0.4 }
  ];

  // d3-scale
  import { scaleLinear, scaleBand } from 'd3-scale';
  import { axisBottom, axisLeft } from 'd3-axis';
  import { select } from 'd3-selection';
  const scale_x = scaleBand()
                  .domain(["Netflix", "Amazon Prime Video", "Disney+", "Hulu", "Apple TV", "Rakuten"])
                  .range([0, innerWidth]);
  const scale_y = scaleLinear()
                  .domain([0, 3])
                  .range([innerHeight, 0]);
  var xAxis = axisBottom(scale_x);
  function x_axis(handle) {
		return xAxis(select(handle))
	}
  var yAxis = axisLeft(scale_y);
  function y_axis(handle) {
		return yAxis(select(handle))
	}
</script>

<style>
  rect {
      fill: steelblue;
  }
</style>

<!-- setting a viewBox and max-width allows the SVG to shrink but not grow! -->
<svg viewbox="0 0 {width} {height}" style="max-width: {width}px">
  <g transform="translate({margin.left},{margin.top})">
    {#each data as datapoint, i} 
      <rect x={i*innerWidth/6+10} y={scale_y(datapoint.viewers)} width="70" height={scale_y(3-datapoint.viewers)} />
    {/each}
  </g>
  <g transform="translate({margin.left}, {margin.top})" use:y_axis>
    <text transform="rotate(270)" x="-90" y="-30" fill="currentcolor">Viewers (Million)</text>
  </g>
  <g transform="translate({margin.left}, {innerHeight+margin.top})" use:x_axis>
  </g>
</svg>
